unit Unit1;

//Lancer une application Dos et rediriger sa sortie standard vers l'application appelante
//Marchioni Valrian - loub1@caramail.com - ICQ#: 30687888
//20/03/2002
//Sources : Bryan Ashby sur borland.public.delphi.winapi
//ATTENTION: Ne gre pas les paramtres passs dans la ligne de commande
//(pour ca, il faut crire quelques routines qui traitent la ligne de commande pour en sparer le chemin et les paramtres)


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function ExecAndGetConsoleOutput (const CommandLine : string;
  var Output : TStringList) : boolean;
var
  Sa            : TSecurityAttributes;
  StartInfo     : TStartupInfo;
  ProcInfo      : TProcessInformation;
  StdOutFile,
  AppProc,
  AppThread     : LongWord;
  RootDir,
  WorkDir,
  StdOutFn      : string;
begin
  Result := FileExists(ExtractFilePath (CommandLine) +
    ExtractFileName (CommandLine));
  if Result then
  begin
    StdOutFile := INVALID_HANDLE_VALUE;
    AppProc := INVALID_HANDLE_VALUE;
    AppThread := INVALID_HANDLE_VALUE;

    try
      RootDir := ExtractFilePath (ParamStr(0));
      WorkDir := ExtractFilePath (CommandLine);

      if not (FileSearch (ExtractFileName (CommandLine), WorkDir) <> '')
then
        WorkDir := RootDir;

      FillChar (Sa, SizeOf(Sa), #0);
      Sa.nLength := SizeOf (Sa);
      Sa.lpSecurityDescriptor := nil;
      Sa.bInheritHandle := TRUE;

      StdOutFn := RootDir + '_tmpoutp.tmp';
      StdOutFile := CreateFile (PChar(StdOutFn), GENERIC_READ or
GENERIC_WRITE,
        FILE_SHARE_READ or FILE_SHARE_WRITE, @Sa, CREATE_ALWAYS,
        FILE_ATTRIBUTE_TEMPORARY or FILE_FLAG_WRITE_THROUGH, 0);

      if StdOutFile <> INVALID_HANDLE_VALUE then
      begin
        FillChar (StartInfo, SizeOf(StartInfo), #0);
        with StartInfo do
        begin
          cb := SizeOf (StartInfo);
          dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
          wShowWindow := SW_HIDE;
          hStdInput := GetStdHandle (STD_INPUT_HANDLE);
          hStdError := StdOutFile;
          hStdOutput := stdOutFile;
        end;

        if CreateProcess (nil, PChar(CommandLine), nil, nil, TRUE, 0, nil,
          PChar(WorkDir), StartInfo, ProcInfo) then
        begin
          WaitForSingleObject (ProcInfo.hProcess, INFINITE);
          AppProc := ProcInfo.hProcess;
          AppThread := ProcInfo.hThread;

          CloseHandle (StdOutFile);
          StdOutFile := INVALID_HANDLE_VALUE;

          Output.Clear;
          Output.LoadFromFile (StdOutFn);
        end;
      end;
    finally
      if StdOutFile <> INVALID_HANDLE_VALUE then
        CloseHandle (StdOutFile);
      if AppProc <> INVALID_HANDLE_VALUE then
        CloseHandle (AppProc);
      if AppThread <> INVALID_HANDLE_VALUE then
        CloseHandle (AppThread);

      if FileExists (StdOutFn) then
        SysUtils.DeleteFile (StdOutFn);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var sortie:TStringList;
begin
sortie:=TStringList.Create;
Sortie.clear;
Memo1.Lines.Clear;
if ExecAndGetConsoleOutput(edit1.Text,Sortie)
  then memo1.Lines.Assign(sortie)
  else memo1.Lines.add('Erreur');
sortie.free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
close
end;

end.
